
require 'timeout'  # for TimeoutError

class IO

  #
  #
  #

  def expect(pat,timeout=60000)
    buf = ''

    case pat
    when String
      e_pat = Regexp.new(Regexp.quote(pat))
    when Regexp
      e_pat = pat
    end

    while true
      if IO.select([self],nil,nil,timeout).nil? then
        raise TimeoutError #result = nil
        break
      end

      c = getc.chr
      buf << c
      if $DEBUG
        STDOUT.print c ; STDOUT.flush
      end
      if mat = e_pat.match(buf) then
        result = [buf,*mat.to_a[1..-1]]
        break
      end
    end

    if block_given? then
      yield result
    else
      return result
    end

    nil
  end

end



=begin test

  require 'test/unit'
  #require 'reactor/select_reactor'

  class TCExpect < Test::Unit::TestCase

    def setup
      #@reactor = SelectReactor.new
      @read, @write = IO.pipe
      #@expect = Expect.new(@read, @reactor)
      #@expect = Expect.new(@read, 1)
      #@expect.timeout = 1
    end

    def test_simple
      @write.puts "TESTING"
      @read.expect "TESTING"
    end

    def test_regex
      @write.puts "TESTING...1...2...3"
      @read.expect /TESTING/
    end

    def test_regex2
      @write.puts "TESTING...1...2...3"
      @read.expect /\d/
    end

    def test_timeout
      @write.puts "TESTING...1...2...3"
      assert_nil( @read.expect 'X', 0 )
    end

    def test_unmatched_message
      @write.puts "TESTING...1...2...3"
      assert_nil( @read.expect("..........", 1) )
    end

  #   def test_ignore
  #     @write.puts "testing"
  #     @write.puts "ignore"
  #     @expect.expect "testing"
  #     @expect.ignore "ignore"
  #     @expect.run
  #   end
  #
  #   def test_reset
  #     @write.puts "testing..."
  #     @expect.expect "testing..."
  #     @expect.run
  #
  #     @expect.reset
  #     @expect.run
  #
  #     @write.puts "test2"
  #     @expect.expect "test2"
  #     @expect.run
  #   end
  #
  #   def test_multiple_chains
  #     @expect.expect "testing...", :chain1
  #     @expect.expect "hmm...", :chain2
  #     @write.puts "testing..."
  #     @write.puts "hmm..."
  #     @expect.run
  # 
  #     @expect.expect "testing...", :chain1
  #     @expect.expect "hmm...", :chain2
  #     @write.puts "hmm..."
  #     @write.puts "testing..."
  #     @expect.run
  #   end

  end

=end
