

require 'facets/core/class/to_module'

class Module

  def inherit( *mods )
    mods.each do |mod|
      cmod = (class << mod; self; end).to_module
      extend cmod
      include mod
    end
    nil
  end

end



#  _____         _
# |_   _|__  ___| |_
#   | |/ _ \/ __| __|
#   | |  __/\__ \ |_
#   |_|\___||___/\__|
#

=begin test

  require 'test/unit'

  class TCInherit1 < Test::Unit::TestCase

    module Foo
      def self.x ; 10 ; end
      def y ; 20 ; end
    end

    module Bar ; inherit Foo ; end

    class X ; inherit Bar ; end

    # test

    def test_001
      assert_equal( 10, Foo.x )
    end

    def test_002
      assert_equal( 10, Bar.x )
    end

    def test_003
      assert_equal( 10, X.x )
    end

    def test_004
      x = X.new
      assert_equal( 20, x.y )
    end

    # These won't work; this solution in non-dynamic.

    #def test_004
    #  def Foo.g ; 30 ; end
    #  assert_equal( 30, Bar.g )
    #end

    #def test_005
    #  #def Foo.g ; 30 ; end
    #  assert_equal( 30, X.g )
    #end

  end

  class TCInherit2 < Test::Unit::TestCase

    module X
      def self.x ; self ; end
      def x ; self ; end
    end
    class  Y ; inherit X ; end
    module Z ; inherit X ; end
    class  Q ; inherit Z ; end

    def test_001
      y = Y.new
      assert_equal( Y, Y.x )
      assert_equal( y, y.x )
    end

    def test_002
      q = Q.new
      assert_equal( Q, Q.x )
      assert_equal( q, q.x )
    end

  end

=end
