
class Module

  # Module returns itself.

  def to_module
    self #.dup
  end

end


class Class

  # Creates a new module by copying the methods of the class.

  #--
  # Unfortunately this is not dynamic. So once created changes to 
  # the original class will not propagate. I.e. It's not inheritance
  # proper --and that'snot possible excecpt by change Ruby source.
  #++

  def to_module
    new_module = Module.new
    mod = self
    ancestors.each do |a|
      a.methods(false).each do |m|
        m1st = mod.method(m)
        new_module.module_eval do
          define_method( m, &m1st )
        end
      end
    end
    new_module
  end

end
