require 'mega/version'

class Module
  # If a module or class has a FILE constant set to __FILE__ and
  # a (optional) SERIES, this method will return a Version.
  # If a load error occurs this will not throw an error,
  # but will simply set the version to UNDEFINED.
  #
  #   Class.version  #=> "UNDEFINED"
  #
  def version
    t = "UNDEFINED"
    if self::FILE
      begin
        t = File.open(self::FILE) { |f| f.ctime.strftime("%y.%m.%d") }
      rescue LoadError
        t = "UNDEFINED"
      end
    end
    s = self::SERIES || 0
    Version.new( "#{s}.#{t}" )
  end
end
