

module Clean

  CORE = [ "funcall", "send", "respond_to?", "equal?", "==", "object_id" ] + [ "dup", "clone", "null" ]

  def self.included( base )

    methods_to_undef = base.instance_methods - CORE

    methods_to_undef.each do |meth|
      base.send( :undef_method, meth )
    end

  end

end



class Module

  PRIME_METHODS = [ "funcall", "send", "respond_to?", "equal?", "==", "object_id" ] + [ "dup", "clone", "null" ]

  def clean( keep=[] )

    methods_to_undef = instance_methods - PRIME_METHODS - keep.collect{ |m| m.to_s }

    methods_to_undef.each do |meth|
      undef_method, meth
    end

  end

end
