
class ImplementationError < StandardError
end

# namespace to store contracts
module InterfaceContracts
end

class Module

  def implements(*klasses)
    klasses.each do |klass|
      unless klass === Class
        InterfaceContracts.module_eval %Q{
          class ::InterfaceContracts::#{klass} < ::#{klass}; end
          #{klass}.freeze
        }
      end
    end
    ifc_str = '[' + klasses.collect { |k| "InterfaceContracts::#{k.name}" }.join(',') + ']'
    ifm = Module.new
    ifm.module_eval %Q{
      def initialize(*args)
        #{ifc_str}.each do |k|
          umeths = k.public_instance_methods(true) - self.public_methods
          if umeths != []
            raise ImplementationError, self.class.name + " as "  + k.name + "\n" + umeths.sort.join(', ')
          end
        end
        super
      end
    }
    class_eval { include ifm }
  end

end

