
# This mixin depends on three methods: #index( i, v ) where _index_ is an Integer,
# and #indicies.

require 'mega/nack'

Iterable = Enumerable


module Indexable

  def indicies
    #
  end

  def fetch( i )
    # raise
  end

  # if writable

  def store( i, v )
    #
  end

  def delete( i )
    #
  end

  # derivative methods

  def keys ; indicies ; end

  def []( i )
    fetch( i )
  end

  def []=( i, v )
    store( i, v )
  end

  # Returns an array of all values for the given list of indexes.
  def fetch_all( *x )
    x = indicies if x.empty?
    x.collect { |i| fetch(i) }
  end

  # Return true if the given index is viable.
  def index?( i )
    indicies.include?( i )
  end
  alias :key?, :index?


  def delete_all( *x )
    x.each { |i| delete( i ) }
  end

  def delete_values( *w )
    indicies.each { |i| delete( i ) if w.include?( fetch(i) ) }
  end


  # Returns a random value.
  #
  def rand_value
    fetch( indicies.at( rand( indicies.size ) ) )
  end
  alias_method :at_rand, :rand_value

  # Return a random index.
  #
  def rand_index
    indicies.at( rand( indicies.size ) )
  end
  alias_method :rand_key, :rand_index

  # Returns a random pair of an index and its value in a two-element array.
  #
  def rand_pair
    i = indicies.at( rand( indicies.size ) )
    [ i, fetch(i)  ]
  end

end
