#  _____         _
# |_   _|__  ___| |_
#   | |/ _ \/ __| __|
#   | |  __/\__ \ |_
#   |_|\___||___/\__|
#
# for lib/facets/more/paramix.rb
#
# Extracted Wed Jul 05 11:47:50 EDT 2006
# Unit Tools Reap Test Extractor
#

require 'facets/more/paramix.rb'


  require 'test/unit'
  require 'facet/kernel/eigenclass'

  class TC01 < Test::Unit::TestCase

    module M
      def f
        M(:p)
      end
      def self.included_with_parameters( base, parms )
        base.class_eval do
          define_method :check do
            parms
          end
        end
      end
    end

    class C
      include M, :p => "check"
    end

    class D
      include M, :p => "steak"
    end

    def test_01_001
      c = C.new
      assert_equal( "check", c.M(:p) )
      assert_equal( "check", c.f )
    end

    def test_01_002
      d = D.new
      assert_equal( "steak", d.M(:p) )
      assert_equal( "steak", d.f )
    end

    def test_01_003
      assert_equal( {M=>{:p => "check"}}, C.mixin_parameters )
      assert_equal( {M=>{:p => "steak"}}, D.mixin_parameters )
    end

    def test_01_004
      c = C.new
      assert_equal( {:p => "check"}, c.check )
      d = D.new
      assert_equal( {:p => "steak"}, d.check )
    end

  end


  class TC02 < Test::Unit::TestCase

    module M
      def f
        M(:p)
      end
    end

    class C
      extend M, :p => "mosh"
    end

    class D
      extend M, :p => "many"
    end

    def test_02_001
      assert_equal( "mosh", C.f )
    end

    def test_02_002
      assert_equal( "many", D.f )
    end

    def test_02_003
      assert_equal( {M=>{:p => "mosh"}}, C.eigenclass.mixin_parameters )
      assert_equal( {M=>{:p => "many"}}, D.eigenclass.mixin_parameters )
    end

  end


